package org.opdyn;

import java.util.Random;

class DeffuantWeisbuch extends Model {

    public DeffuantWeisbuch(int agents, double lowerBound, double upperBound) {
        
        super(agents, lowerBound, upperBound);
        
    }
    
    @Override
    public void timeStep() {
   
        for (int k=0; k < Math.min((int) (agents/10), 100); k++) {   
            singleStep();   
        }
            
        dataset.setNotify(false);
        for (int i=0; i < agents; i++) {
            dataset.getSeries(i).add(opinions[i], (double) time);
        }
        dataset.setNotify(true);

        compDistribution(); 
        
    }

    public void singleStep() {
   
        // choose two random agents who interact
        Random rn = new Random();
        int agent1 = rn.nextInt(agents);
        int agent2 = rn.nextInt(agents);
        
        double op1 = opinions[agent1];
        double op2 = opinions[agent2];
        double c = op2 - op1;
           
        if (c > 0) {
           if (c <= upperBound) {
               opinions[agent1] = 0.5 * (op1 + op2);
           }
           if (c <= lowerBound) {
               opinions[agent2] = 0.5 * (op1 + op2);
           }
        }
        else {
           if ((-c) <= lowerBound) {
               opinions[agent1] = 0.5 * (op1 + op2);
           }
           if ((-c) <= upperBound) {
               opinions[agent2] = 0.5 * (op1 + op2);
           }
        }
  
        time++;

    }

}
